using System;
using UnityEngine;

// Token: 0x020001EB RID: 491
public class WeaponsAttach : MonoBehaviour
{
	// Token: 0x06000A37 RID: 2615 RVA: 0x00009207 File Offset: 0x00007407
	private void Awake()
	{
		this.PhysicalBehaviour = base.GetComponent<PhysicalBehaviour>();
	}

	// Token: 0x06000A38 RID: 2616 RVA: 0x0002FD1C File Offset: 0x0002DF1C
	private void FixedUpdate()
	{
		float num = this.BaseIntensity * Mathf.Max(1f, this.PhysicalBehaviour.Charge * this.ChargeMultiplierMultiplier);
		float num2 = this.BaseRange * Mathf.Max(1f, this.PhysicalBehaviour.Charge * this.ChargeMultiplierMultiplier);
		foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
		{
			if (!(physicalBehaviour == this.PhysicalBehaviour) && physicalBehaviour.Properties.Conducting)
			{
				Vector2 a = physicalBehaviour.transform.position - base.transform.position;
				if (this.Reversed)
				{
					a *= -1f;
				}
				if (a.sqrMagnitude <= num2 * num2)
				{
					Vector2 vector = a.normalized * -num / a.sqrMagnitude * physicalBehaviour.Properties.MagneticAttractionIntensity * physicalBehaviour.rigidbody.mass;
					physicalBehaviour.rigidbody.AddForce(vector, ForceMode2D.Force);
					this.PhysicalBehaviour.rigidbody.AddForce(-vector, ForceMode2D.Force);
				}
			}
		}
	}

	// Token: 0x06000A39 RID: 2617 RVA: 0x00009215 File Offset: 0x00007415
	public WeaponsAttach()
	{
	}

	// Token: 0x04000929 RID: 2345
	public float BaseRange = 15f;

	// Token: 0x0400092A RID: 2346
	public float BaseIntensity = 5f;

	// Token: 0x0400092B RID: 2347
	public float ChargeMultiplierMultiplier = 1f;

	// Token: 0x0400092C RID: 2348
	public float JointCreationDistanceThreshold = 0.1f;

	// Token: 0x0400092D RID: 2349
	public bool Reversed;

	// Token: 0x0400092E RID: 2350
	public ParticleSystem particleSystem;

	// Token: 0x0400092F RID: 2351
	public AudioSource audioSource;

	// Token: 0x04000930 RID: 2352
	public bool Activated;

	// Token: 0x04000931 RID: 2353
	private PhysicalBehaviour PhysicalBehaviour;
}
